/*
 * Example 3 during tutorials on April 5, 2016.
 * Modified from example given by Prof. Manzara.
 */
public class DepositError {
	public static void main(String[] args) {
		// Create one account to be shared between Clients.
		BankAccount sharedAccount = new BankAccount();
		
		// Deposit $100 to the account.
		sharedAccount.deposit(100);
		
		// Create two Clients sharing the same (joint) account.
		Client accountOwnerOne = new Client(sharedAccount);
		Client accountOwnerTwo = new Client(sharedAccount);

		// Start both threads (ie. have each Client withdraw $100).
		accountOwnerOne.start();
		accountOwnerTwo.start();
		
		// We wait a few seconds before checking the balance so that the above threads can complete.
		// If we do not wait, we might end up checking the balance before either of the above threads
		// try to withdraw anything.
		try {
			Thread.sleep(3000);
			
			// If your withdraw method is synchronized, the first Client will withdraw the $100 and the second
			// Client will be told "Insufficient funds." If withdraw is not a synchronized method, both Clients
			// will withdraw from the account, leaving you with -$100.
			System.out.println("Account balance: " + sharedAccount.getBalance());
		} catch (InterruptedException e) {
			System.exit(0);
		}
	}
}
